// 005 u_c_text_shape_adapter_6
// 11 dec 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   Felix John COLIBRI  http://www.felix-colibri.com

(*$r+*)

// -- an adapter OBJECT (not adapter CLASS)

unit u_c_text_shape_adapter_6;
  interface
    uses Windows, u_c_manipulator_6, u_c_shape_6, u_c_text_view_6;

    type c_text_shape_adapter= class(c_shape)
                                 _m_c_text_view: c_text_view;

                                 Constructor create_text_shape_adapter(p_c_text_view: c_text_view);

                                 procedure get_bounding_box(var pv_top_left, pv_bottom_right: tPoint); Override;
                                 function f_c_create_manipulator: c_manipulator; Override;

                                 function f_is_empty: Boolean;

                                 Destructor Destroy; Override;
                               end; // c_text_shape_adapter

  implementation
    uses Types; // function Point

    // -- c_text_shape_adapter

    Constructor c_text_shape_adapter.create_text_shape_adapter(p_c_text_view: c_text_view);
      begin
        Inherited Create;
        _m_c_text_view:= p_c_text_view;
      end; // create_text_shape_adapter

    procedure c_text_shape_adapter.get_bounding_box(var pv_top_left, pv_bottom_right: tPoint);
      var l_x, l_y, l_height, l_width: Integer;
      begin
        _m_c_text_view.get_origin(l_x, l_y);
        _m_c_text_view.get_extent(l_height, l_width);
        pv_top_left:= Point(l_x, l_y);
        pv_bottom_right:= Point(l_x+ l_height, l_y+ l_width);
      end; // get_bounding_box

    function c_text_shape_adapter.f_c_create_manipulator: c_manipulator;
      begin
        Result:= c_manipulator.create_manipulator;
      end; // f_c_create_manipulator

    function c_text_shape_adapter.f_is_empty: Boolean;
      begin
        Result:= _m_c_text_view.f_is_empty;
      end; // f_is_empty

    Destructor c_text_shape_adapter.Destroy;
      begin
        Inherited;
      end; // Destroy

    begin // u_c_text_shape_adapter
    end. // u_c_text_shape_adapter
